﻿/* 
 * Filename:
 * vehicle_service.sqf 
 *
 * Description:
 * Repair/Rearm/Refuel script
 * 
 * Created by [KH]Jman
 * Creation date: 05/09/2013
 * Email: jman@kellys-heroes.eu
 * Web: http://www.kellys-heroes.eu
 * 
 * */

// ====================================================================================

private ["_config","_count","_i","_magazines","_object","_type","_type_name"];

_object = _this select 0;
_type = typeof _object;
if (_object isKindOf "ParachuteBase") exitWith {};
if (isNil "reloadTime") then {reloadTime = 1;};
if (!alive _object) exitWith {};
_object setFuel 0;
_object setVehicleAmmo 1;
_type_name = typeOf _object;
_object vehicleChat format ["Servicing %1... Please stand by...", _type];
_magazines = getArray(configFile >> "CfgVehicles" >> _type >> "magazines");

if (count _magazines > 0) then {
	_removed = [];
	{
		if (!(_x in _removed)) then {
			_object removeMagazines _x;
			_removed set [count _removed, _x];
		};
	} forEach _magazines;
	{
		_object vehicleChat format ["Reloading %1", _x];
		sleep reloadTime;
		if (!alive _object) exitWith {};
		_object addMagazine _x;
	} forEach _magazines;
};

_count = count (configFile >> "CfgVehicles" >> _type >> "Turrets");

if (_count > 0) then {
	for "_i" from 0 to (_count - 1) do {
		scopeName "reloadIt";
		_config = (configFile >> "CfgVehicles" >> _type >> "Turrets") select _i;
		_magazines = getArray(_config >> "magazines");
		_removed = [];
		{
			if (!(_x in _removed)) then {
				_object removeMagazines _x;
				_removed set [count _removed, _x];
			};
		} forEach _magazines;
		{
			_object vehicleChat format ["Reloading %1", _x];
			sleep reloadTime;
			if (!alive _object) then {breakOut "reloadIt"};
			_object addMagazine _x;
			sleep reloadTime;
			if (!alive _object) then {breakOut "reloadIt"};
		} forEach _magazines;
		_count_other = count (_config >> "Turrets");
		if (_count_other > 0) then {
			for "_i" from 0 to (_count_other - 1) do {
				_config2 = (_config >> "Turrets") select _i;
				_magazines = getArray(_config2 >> "magazines");
				_removed = [];
				{
					if (!(_x in _removed)) then {
						_object removeMagazines _x;
						_removed set [count _removed, _x];
					};
				} forEach _magazines;
				{
					_object vehicleChat format ["Reloading %1", _x]; 
					sleep reloadTime;
					if (!alive _object) then {breakOut "reloadIt"};
					_object addMagazine _x;
					sleep reloadTime;
					if (!alive _object) then {breakOut "reloadIt"};
				} forEach _magazines;
			};
		};
	};
};

_object setVehicleAmmo 1;
sleep reloadTime;
if (!alive _object) exitWith {};
_object vehicleChat "Repairing vehicle...";
_object setDamage 0;
sleep reloadTime;
if (!alive _object) exitWith {};
_object vehicleChat "Refueling vehicle...";
while {fuel _object < 0.99} do {
	_object setFuel 1;
	sleep 0.01;
};
sleep reloadTime;
if (!alive _object) exitWith {};
_object vehicleChat format ["%1 is ready...", _type_name];
if (true) exitWith {};